module.exports = function(request, url, cb) {

    var options = {
        url: request.headers["sharepoint-host-url"] + url,
        json: true,
        headers: {
            Authorization : "Bearer " + request.headers.token
        },
        secureOptions: require("constants").SSL_OP_NO_TLSv1_2
    };

    require("request").get(options, function(error, response, body) {
        if (error || response.statusCode !== 200 ) {
            var err = new Error();
            if (error)
                err.message = error;
            else {
                try {
                    err.message = "odata error : " + body["odata.error"]["message"]["value"];
                    err.odata = body;
                }
                catch(e) {
                    err.message = "Unknown odata error. " + body;
                }
            }

            return cb(err);
        }
        cb(null, body);
    });
};



